## seccure 0.3

=== Makefile ===
CFLAGS = -O2 # -D NOBEEP # -D NOMEMLOCK

default: binaries # doc

binaries: seccure-key seccure-encrypt seccure-decrypt seccure-sign \
	seccure-verify seccure-signcrypt seccure-veridec seccure-dh

doc: seccure.1 seccure.1.html

install: default
	install -m0755 seccure-key $(DESTDIR)/usr/bin
	ln -f $(DESTDIR)/usr/bin/seccure-key $(DESTDIR)/usr/bin/seccure-encrypt
	ln -f $(DESTDIR)/usr/bin/seccure-key $(DESTDIR)/usr/bin/seccure-decrypt
	ln -f $(DESTDIR)/usr/bin/seccure-key $(DESTDIR)/usr/bin/seccure-sign
	ln -f $(DESTDIR)/usr/bin/seccure-key $(DESTDIR)/usr/bin/seccure-verify
	ln -f $(DESTDIR)/usr/bin/seccure-key $(DESTDIR)/usr/bin/seccure-signcrypt
	ln -f $(DESTDIR)/usr/bin/seccure-key $(DESTDIR)/usr/bin/seccure-veridec
	ln -f $(DESTDIR)/usr/bin/seccure-key $(DESTDIR)/usr/bin/seccure-dh
	install -m0644 seccure.1 $(DESTDIR)/usr/share/man/man1

clean:
	rm -f *.o seccure-key seccure-encrypt seccure-decrypt seccure-sign \
	seccure-verify seccure-signcrypt seccure-veridec \
	seccure-dh # seccure.1 seccure.1.html

rebuild: clean default



seccure-key: seccure.o numtheory.o ecc.o serialize.o protocol.o curves.o aes256ctr.o
	$(CC) $(CFLAGS) -o seccure-key -lgcrypt seccure.o numtheory.o ecc.o \
	curves.o serialize.o protocol.o aes256ctr.o

seccure-encrypt: seccure-key
	ln -f seccure-key seccure-encrypt

seccure-decrypt: seccure-key
	ln -f seccure-key seccure-decrypt

seccure-sign: seccure-key
	ln -f seccure-key seccure-sign

seccure-verify: seccure-key
	ln -f seccure-key seccure-verify

seccure-signcrypt: seccure-key
	ln -f seccure-key seccure-signcrypt

seccure-veridec: seccure-key
	ln -f seccure-key seccure-veridec

seccure-dh: seccure-key
	ln -f seccure-key seccure-dh

seccure.o: seccure.c
	$(CC) $(CFLAGS) -c seccure.c

numtheory.o: numtheory.c numtheory.h
	$(CC) $(CFLAGS) -c numtheory.c

ecc.o: ecc.c ecc.h
	$(CC) $(CFLAGS) -c ecc.c

curves.o: curves.c curves.h
	$(CC) $(CFLAGS) -c curves.c

serialize.o: serialize.c serialize.h
	$(CC) $(CFLAGS) -c serialize.c

protocol.o: protocol.c protocol.h
	$(CC) $(CFLAGS) -c protocol.c

aes256ctr.o: aes256ctr.c aes256ctr.h
	$(CC) $(CFLAGS) -c aes256ctr.c


seccure.1: seccure.manpage.xml
	xmltoman seccure.manpage.xml > seccure.1

seccure.1.html: seccure.manpage.xml
	xmlmantohtml seccure.manpage.xml > seccure.1.html

## seccure 0.4

=== Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-CFLAGS = -O2 # -D NOBEEP # -D NOMEMLOCK
+CFLAGS = -O2 -Wall # -D NOBEEP
 
 default: binaries # doc
 
@@ -19,7 +19,7 @@
 	install -m0644 seccure.1 $(DESTDIR)/usr/share/man/man1
 
 clean:
-	rm -f *.o seccure-key seccure-encrypt seccure-decrypt seccure-sign \
+	rm -f *.o *~ seccure-key seccure-encrypt seccure-decrypt seccure-sign \
 	seccure-verify seccure-signcrypt seccure-veridec \
 	seccure-dh # seccure.1 seccure.1.html
 
@@ -30,6 +30,7 @@
 seccure-key: seccure.o numtheory.o ecc.o serialize.o protocol.o curves.o aes256ctr.o
 	$(CC) $(CFLAGS) -o seccure-key -lgcrypt seccure.o numtheory.o ecc.o \
 	curves.o serialize.o protocol.o aes256ctr.o
+	strip seccure-key
 
 seccure-encrypt: seccure-key
 	ln -f seccure-key seccure-encrypt
@@ -79,4 +80,3 @@
 
 seccure.1.html: seccure.manpage.xml
 	xmlmantohtml seccure.manpage.xml > seccure.1.html
-

=== test/Makefile ===
SECCURE-PATH = "../"
SECCURE-KEY = $(SECCURE-PATH)"seccure-key"
SECCURE-ENCRYPT = $(SECCURE-PATH)"seccure-encrypt"
SECCURE-DECRYPT = $(SECCURE-PATH)"seccure-decrypt"
SECCURE-SIGN = $(SECCURE-PATH)"seccure-sign"
SECCURE-VERIFY = $(SECCURE-PATH)"seccure-verify"
SECCURE-SIGNCRYPT = $(SECCURE-PATH)"seccure-signcrypt"
SECCURE-VERIDEC = $(SECCURE-PATH)"seccure-veridec"

ENCCURVE = "p128"
SIGCURVE = "p256"
MACLEN = "64"


default: encdec-test signveri-test signcrypt-test

clean:
	rm -f public-encryption-key public-signature-key message.enc message.aux message.sig

rebuild: clean default

public-encryption-key: secret-encryption-key
	$(SECCURE-KEY) -c $(ENCCURVE) -F secret-encryption-key -q > public-encryption-key

public-signature-key: secret-signature-key
	$(SECCURE-KEY) -c $(SIGCURVE) -F secret-signature-key -q > public-signature-key

encdec-test: public-encryption-key
	$(SECCURE-ENCRYPT) -m $(MACLEN) -i message.txt -o message.enc -- `cat public-encryption-key`
	$(SECCURE-DECRYPT) -m $(MACLEN) -c $(ENCCURVE) -i message.enc -o message.aux -F secret-encryption-key
	cmp message.txt message.aux
	rm -f message.enc message.aux

signveri-test: public-signature-key
	$(SECCURE-SIGN) -c $(SIGCURVE) -s message.sig -i message.txt -F secret-signature-key
	$(SECCURE-VERIFY) -s message.sig -i message.txt -- `cat public-signature-key`
	rm -f message.sig

signcrypt-test: public-encryption-key public-signature-key
	$(SECCURE-SIGNCRYPT) -c $(SIGCURVE) -i message.txt -o message.enc -F secret-signature-key -- `cat public-encryption-key`
	$(SECCURE-VERIDEC) -c $(ENCCURVE) -i message.enc -o message.aux -F secret-encryption-key -- `cat public-signature-key`
	cmp message.txt message.aux
	rm -f message.enc message.aux

=== debian/changelog ===
seccure (0.4-0.1) unstable; urgency=low

  * Non-Maintainer Upload
  * New upstream version (Closes: #671667)
   - upstream secure memory overhaul, dropping now-unneeded memlock patch
  * refresh patches
  * convert packaging to dh 9
  * convert to 3.0 (quilt) (Closes: #664390)
  * bump Standards-Version to 3.9.5 (no changes needed)
  * ensure use of LDFLAGS during compilation
  * added debian/watch
  * debian/copyright: convert to machine-readable format
  * run test suite

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Wed, 05 Feb 2014 00:19:00 -0500

seccure (0.3-3) unstable; urgency=low

  * Modify the patch added in the last upload to enable gcrypt's secure
    memory, as apparently not disabling it is different to enabling it.
    (Closes: #489835)

 -- James Westby <jw+debian@jameswestby.net>  Tue, 16 Sep 2008 14:41:18 +0100

seccure (0.3-2) unstable; urgency=low

  * Make failure to mlock all memory only a warning, and re-enable gcrypt's
    memory locking. Changes in pam since etch mean that the kernel's defaults
    for memory locking are now respected, and seccure tries to lock more
    memory than that, which means that the program can't be started. The patch
    is from the upstream author, who considers it a stop-gap, but doesn't
    anticipate having a proper fix before lenny. (Closes: #489835)
  * Don't ignore "$(MAKE) clean" errors. The normal reason for this is the use
    of autotools leading to the makefile not necessarily being present when
    the clean target is run, be this package doesn't use autotools, so that
    won't happen.
  * Add a description to debian/patches/10-man-hyphen.dpatch.
  * Update the standards version to 3.8.0 (no changes required).
  * Release team: this isn't the diff that I sent you, I apologise. My sponsor
    suggested that fixing these small things wouldn't be a problem.

 -- James Westby <jw+debian@jameswestby.net>  Wed, 06 Aug 2008 11:33:27 +0100

seccure (0.3-1) unstable; urgency=low

  * New upstream release.

 -- James Westby <jw+debian@jameswestby.net>  Thu,  7 Sep 2006 20:34:30 +0100

seccure (0.2-1) unstable; urgency=low

  * Initial release (Closes: #378987)  

 -- James Westby <jw+debian@jameswestby.net>  Tue, 25 Jul 2006 03:42:20 +0100

=== debian/control ===
Source: seccure
Section: utils
Priority: optional
Maintainer: James Westby <jw+debian@jameswestby.net>
Build-Depends: debhelper (>= 9), libgcrypt-dev, xmltoman
Homepage: http://point-at-infinity.org/seccure/
Standards-Version: 3.9.5
Vcs-Git: git://git.debian.org/collab-maint/seccure.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/seccure.git;a=summary

Package: seccure
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: tools for using algorithms based on elliptic curve cryptography (ECC)
 The seccure toolset implements a selection of asymmetric algorithms
 based on elliptic curve cryptography (ECC). In particular, it offers
 public key encryption / decryption and signature generation /
 verification. ECC schemes offer a much better key size to security
 ratio than classical systems (RSA, DSA). Keys are short enough to make
 direct specification of keys on the command line possible (sometimes
 this is more convenient than the management of PGP-like key
 rings). seccure builds on this feature and therefore is the tool of
 choice whenever lightweight asymmetric cryptography -- independent of
 key servers, revocation certificates, the Web of Trust, or even
 configuration files -- is required.
 .
 The toolkit implements Diffie-Hellman key exchange, allowing you to agree a
 key with another party over an insecure channel. The Diffie Helman protocol
 affords forward secrecy, and requires no previous contact with the other 
 party.
 .
 The seccure toolset allows you to select the curve that the operations are 
 performed on, so that different cryptographic needs can be supported. This
 is currently the only ECC package in Debian GNU/Linux to offer a choice of 
 curves and MAC lengths.
 .
 It is currently missing some of the functionality of the sks-ecc package, 
 including encrypting to multiple recipients at once, and creating different
 signature formats.

## seccure 0.5

=== Makefile ===
--- 
+++ 
@@ -1,4 +1,5 @@
-CFLAGS = -O2 -Wall # -D NOBEEP
+CFLAGS = -O2 -Wall -Wextra -std=c89 -pedantic -D_POSIX_C_SOURCE=200112 # -D NOBEEP
+LIBS = -lgcrypt
 
 default: binaries # doc
 
@@ -28,8 +29,8 @@
 
 
 seccure-key: seccure.o numtheory.o ecc.o serialize.o protocol.o curves.o aes256ctr.o
-	$(CC) $(CFLAGS) -o seccure-key -lgcrypt seccure.o numtheory.o ecc.o \
-	curves.o serialize.o protocol.o aes256ctr.o
+	$(CC) $(CFLAGS) -o seccure-key seccure.o numtheory.o ecc.o \
+	curves.o serialize.o protocol.o aes256ctr.o $(LIBS)
 	strip seccure-key
 
 seccure-encrypt: seccure-key

=== test/Makefile ===
--- 
+++ 
@@ -7,8 +7,8 @@
 SECCURE-SIGNCRYPT = $(SECCURE-PATH)"seccure-signcrypt"
 SECCURE-VERIDEC = $(SECCURE-PATH)"seccure-veridec"
 
-ENCCURVE = "p128"
-SIGCURVE = "p256"
+ENCCURVE = "brainpoolp192r1"
+SIGCURVE = "brainpoolp512r1"
 MACLEN = "64"
 
 
@@ -26,18 +26,18 @@
 	$(SECCURE-KEY) -c $(SIGCURVE) -F secret-signature-key -q > public-signature-key
 
 encdec-test: public-encryption-key
-	$(SECCURE-ENCRYPT) -m $(MACLEN) -i message.txt -o message.enc -- `cat public-encryption-key`
+	$(SECCURE-ENCRYPT) -m $(MACLEN) -c $(ENCCURVE) -i message.txt -o message.enc -- `cat public-encryption-key`
 	$(SECCURE-DECRYPT) -m $(MACLEN) -c $(ENCCURVE) -i message.enc -o message.aux -F secret-encryption-key
 	cmp message.txt message.aux
 	rm -f message.enc message.aux
 
 signveri-test: public-signature-key
 	$(SECCURE-SIGN) -c $(SIGCURVE) -s message.sig -i message.txt -F secret-signature-key
-	$(SECCURE-VERIFY) -s message.sig -i message.txt -- `cat public-signature-key`
+	$(SECCURE-VERIFY) -c $(SIGCURVE) -s message.sig -i message.txt -- `cat public-signature-key`
 	rm -f message.sig
 
 signcrypt-test: public-encryption-key public-signature-key
-	$(SECCURE-SIGNCRYPT) -c $(SIGCURVE) -i message.txt -o message.enc -F secret-signature-key -- `cat public-encryption-key`
-	$(SECCURE-VERIDEC) -c $(ENCCURVE) -i message.enc -o message.aux -F secret-encryption-key -- `cat public-signature-key`
+	$(SECCURE-SIGNCRYPT) -c $(SIGCURVE) -c $(ENCCURVE) -i message.txt -o message.enc -F secret-signature-key -- `cat public-encryption-key`
+	$(SECCURE-VERIDEC) -c $(ENCCURVE) -c $(SIGCURVE) -i message.enc -o message.aux -F secret-encryption-key -- `cat public-signature-key`
 	cmp message.txt message.aux
 	rm -f message.enc message.aux

=== debian/changelog ===
seccure (0.5-1) unstable; urgency=medium

  * New maintainer. Thanks James! (Closes: #797688)
  * Imported Upstream version 0.5
  * d/patches: refresh
  * d/copyright: update & switch GPL-2+ to LGPL-3+
  
 -- Tomasz Buchert <tomasz@debian.org>  Thu, 03 Sep 2015 11:14:26 +0200

=== debian/control ===
--- 
+++ 
@@ -1,12 +1,12 @@
 Source: seccure
 Section: utils
 Priority: optional
-Maintainer: James Westby <jw+debian@jameswestby.net>
+Maintainer: Tomasz Buchert <tomasz@debian.org>
 Build-Depends: debhelper (>= 9), libgcrypt-dev, xmltoman
 Homepage: http://point-at-infinity.org/seccure/
-Standards-Version: 3.9.5
-Vcs-Git: git://git.debian.org/collab-maint/seccure.git
-Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/seccure.git;a=summary
+Standards-Version: 3.9.6
+Vcs-Git: git://anonscm.debian.org/collab-maint/seccure.git
+Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/seccure.git
 
 Package: seccure
 Architecture: any

=== debian/rules ===
#!/usr/bin/make -f
%:
	dh $@

override_dh_auto_build:
	dh_auto_build
	make seccure.1

override_dh_installchangelogs:
	dh_installchangelogs HISTORY

override_dh_auto_test:
	cd test && make

=== debian/watch ===
version=3
http://point-at-infinity.org/seccure/seccure-([\d\.]+)\.tar\.gz
